/* -*- mode: c; c-basic-offset: 4; -*- */
#if HAVE_CONFIG_H
#include "daq_config.h"
#endif /*HAVE_CONFIG_H */

#include <stdarg.h>
#include <stdio.h>

#include "daqc.h"
#include "nds_log.h"
#include "nds_os.h"

extern int mexPrintf( const char* fmt, ... );

void
nds_log( const char* fmt, ... )
{
    char fmt_buf[2048];
    char buf[2048];
    va_list	ap;

    va_start( ap, fmt );

#if HAVE_SPRINTF_S
    sprintf_s
#else /* HAVE_SPRINTF_S */
    sprintf
#endif /* HAVE_SPRINTF_S */
    ( fmt_buf,
#if HAVE_SPRINTF_S
      sizeof( buf ),
#endif /* HAVE_SPRINTF_S */
      "matlab:nds_log: %s", fmt );

#if HAVE_VSNPRINTF_S
    vsnprintf_s
#else /* HAVE_VSNPRINTF_S */
    vsnprintf
#endif /* HAVE_VSNPRINTF_S */
    ( buf, sizeof( buf ),
#if HAVE_VSNPRINTF_S
      sizeof( buf ) - 1,
#endif /* HAVE_VSNPRINTF_S */
      fmt_buf, ap );

    mexPrintf( buf );

    va_end( ap );
}
